// Type Library: GCAD32.OLB  GammaCAD Drawing Automation Server
// GammaCAD PRO 1.0 {735AAEE2-92C1-11CF-A8F8-444553540000}\409

#include <ocf/automacr.h>

class TOcControlEvent;
class TOcControl;
class TOcxView;
class ArcElem;
class BmpElem;
class CircleElem;
class FillElem;
class TGcadApp;
class InsertElem;
class LineElem;
class PlineElem;
class PointElem;
class TextElem;
class GcadOleView;

// TKIND_DISPATCH: ArcElem 1.0 {735AAEE6-92C1-11CF-A8F8-444553540000}\409 Arc Element Class

class ArcElem : public TAutoProxy {
  public:
    ArcElem() : TAutoProxy(0x409) {}
    // 
    void GetCenterPoint(double far* X, double far* Y); // [id(1), method]
    // 
    long GetColor(); // [id(2), method]
    // 
    long GetType(); // [id(3), method]
    // 
    double GetWidth(); // [id(4), method]
    // 
    double GetStartAngle(); // [id(5), method]
    // 
    double GetEndAngle(); // [id(6), method]
    // 
    double GetRadius(); // [id(7), method]
};

// TKIND_DISPATCH: BmpElem 1.0 {735AAEE7-92C1-11CF-A8F8-444553540000}\409 Bmp Element Class

class BmpElem : public TAutoProxy {
  public:
    BmpElem() : TAutoProxy(0x409) {}
    // 
    void GetFirstPoint(double far* X, double far* Y); // [id(1), method]
    // 
    void GetSecondPoint(double far* X, double far* Y); // [id(2), method]
    // 
    bool GetScale(); // [id(3), method]
};

// TKIND_DISPATCH: CircleElem 1.0 {735AAEE8-92C1-11CF-A8F8-444553540000}\409 Circle Element Class

class CircleElem : public TAutoProxy {
  public:
    CircleElem() : TAutoProxy(0x409) {}
    // 
    void GetCenterPoint(double far* X, double far* Y); // [id(1), method]
    // 
    long GetColor(); // [id(2), method]
    // 
    long GetType(); // [id(3), method]
    // 
    double GetWidth(); // [id(4), method]
    // 
    double GetRadius(); // [id(5), method]
};

// TKIND_DISPATCH: FillElem 1.0 {735AAEE9-92C1-11CF-A8F8-444553540000}\409 Fill Element Class

class FillElem : public TAutoProxy {
  public:
    FillElem() : TAutoProxy(0x409) {}
    // 
    void GetFirstVertex(double far* X, double far* Y); // [id(1), method]
    // 
    bool GetNextVertex(double far* X, double far* Y); // [id(2), method]
    // 
    long GetColor(); // [id(3), method]
    // 
    long GetType(); // [id(4), method]
};

// TKIND_DISPATCH: TGcadApp 1.0 {735AAEEA-92C1-11CF-A8F8-444553540000}\409 Application class

class TGcadApp : public TAutoProxy {
  public:
    TGcadApp() : TAutoProxy(0x409) {}
    // Main window shown
    bool GetVisible();     // [id(1), prop r/w]
    void SetVisible(bool); // [id(1), prop r/w]
    // Create a new document
    bool NewDocument(); // [id(2), method]
    // Open an existing document
    bool OpenDocument(TAutoString Name); // [id(3), method]
    // Save document
    bool SaveDocument(); // [id(4), method]
    // Save document to specified file
    bool SaveDocumentAs(TAutoString Name); // [id(5), method]
    // 
    bool LoadSymbolLib(TAutoString symFname); // [id(6), method]
    // Get drawing view
    void GetView(GcadOleView&); // [id(7), method]
    // Application name
    TAutoString GetName(); // [id(8), propget]
    // Complete path to application
    TAutoString GetFullName(); // [id(9), propget]
    // Application object
    void GetApplication(TGcadApp&); // [id(10), propget]
    // Quit application
    void Quit(); // [id(11), method]
};

// TKIND_DISPATCH: InsertElem 1.0 {735AAEEB-92C1-11CF-A8F8-444553540000}\409 Insert Element Class

class InsertElem : public TAutoProxy {
  public:
    InsertElem() : TAutoProxy(0x409) {}
    // 
    void GetInsertPoint(double far* X, double far* Y); // [id(1), method]
    // 
    TAutoString GetName(); // [id(2), method]
    // 
    double GetRotation(); // [id(3), method]
    // 
    void GetScale(double far* xfact, double far* yfact); // [id(4), method]
};

// TKIND_DISPATCH: LineElem 1.0 {735AAEEC-92C1-11CF-A8F8-444553540000}\409 Line Element Class

class LineElem : public TAutoProxy {
  public:
    LineElem() : TAutoProxy(0x409) {}
    // 
    void GetFirstPoint(double far* X, double far* Y); // [id(1), method]
    // 
    void GetSecondPoint(double far* X, double far* Y); // [id(2), method]
    // 
    long GetColor(); // [id(3), method]
    // 
    long GetType(); // [id(4), method]
    // 
    double GetWidth(); // [id(5), method]
};

// TKIND_DISPATCH: PlineElem 1.0 {735AAEED-92C1-11CF-A8F8-444553540000}\409 Pline Element Class

class PlineElem : public TAutoProxy {
  public:
    PlineElem() : TAutoProxy(0x409) {}
    // 
    void GetFirstVertex(double far* X, double far* Y); // [id(1), method]
    // 
    bool GetNextVertex(double far* X, double far* Y); // [id(2), method]
    // 
    long GetColor(); // [id(3), method]
    // 
    long GetType(); // [id(4), method]
    // 
    double GetWidth(); // [id(5), method]
    // 
    long GetClosed(); // [id(6), method]
};

// TKIND_DISPATCH: PointElem 1.0 {735AAEEE-92C1-11CF-A8F8-444553540000}\409 Point Element Class

class PointElem : public TAutoProxy {
  public:
    PointElem() : TAutoProxy(0x409) {}
    // 
    void GetPoint(double far* X, double far* Y); // [id(1), method]
    // 
    long GetColor(); // [id(2), method]
    // 
    long GetType(); // [id(3), method]
    // 
    double GetSize(); // [id(4), method]
};

// TKIND_DISPATCH: TextElem 1.0 {735AAEEF-92C1-11CF-A8F8-444553540000}\409 Text Element Class

class TextElem : public TAutoProxy {
  public:
    TextElem() : TAutoProxy(0x409) {}
    // 
    void GetAlignPoint(double far* X, double far* Y); // [id(1), method]
    // 
    long GetColor(); // [id(2), method]
    // 
    double GetHeight(); // [id(3), method]
    // 
    double GetAngle(); // [id(4), method]
    // 
    double GetOrient(); // [id(5), method]
    // 
    double GetWidth(); // [id(6), method]
    // 
    long GetJust(); // [id(7), method]
    // 
    TAutoString GetString(); // [id(8), method]
};

// TKIND_DISPATCH: GcadOleView 1.0 {735AAEF0-92C1-11CF-A8F8-444553540000}\409 GammaCAD View Class

class GcadOleView : public TAutoProxy {
  public:
    GcadOleView() : TAutoProxy(0x409) {}
    // 
    TAutoString GetFirstLayer(); // [id(1), propget]
    // 
    TAutoString GetNextLayer(); // [id(2), propget]
    // 
    bool GetDeviceWindow(long far* x1, long far* y1, long far* x2, long far* y2); // [id(3), method]
    // 
    bool GetWorldWindow(double far* x1, double far* y1, double far* x2, double far* y2); // [id(4), method]
    // 
    bool SetPlotScale(double scale, long metric); // [id(5), method]
    // 
    bool SetPlotOrigin(double X, double Y); // [id(6), method]
    // 
    bool DxfIn(TAutoString filename); // [id(7), method]
    // 
    bool DxfOut(TAutoString filename); // [id(8), method]
    // 
    bool CreateLine(double x1, double y1, double x2, double y2); // [id(9), method]
    // 
    bool CreateArc(double xc, double yc, double x1, double y1, double x2, double y2); // [id(10), method]
    // 
    bool CreateCircle(double xc, double yc, double dist); // [id(11), method]
    // 
    bool CreateEllipse(double xc, double yc, double x1, double y1, double x2, double y2); // [id(12), method]
    // 
    bool CreatePoint(double x1, double y1); // [id(13), method]
    // 
    bool CreateText(double x1, double y1, TAutoString text); // [id(14), method]
    // 
    bool CreateSymbol(double x1, double y1, TAutoString symName, double rot, double xsc, double ysc); // [id(15), method]
    // 
    bool CreateLeader(double x1, double y1, double x2, double y2, TAutoString text); // [id(16), method]
    // 
    bool CreateLinearDim(double x1, double y1, double x2, double y2, double x3, double y3, double dist, double ang, TAutoString text); // [id(17), method]
    // 
    bool StartPline(double x1, double y1, bool closed); // [id(18), method]
    // 
    bool AddPlineVertex(double x1, double y1); // [id(19), method]
    // 
    bool EndPline(); // [id(20), method]
    // 
    bool CreateRect(double x1, double y1, double x2, double y2); // [id(21), method]
    // 
    bool CreateFill(long elemId); // [id(22), method]
    // 
    bool CreateBmp(TAutoString dibPath, double x1, double y1, double x2, double y2, bool scale); // [id(23), method]
    // 
    void Undo(); // [id(24), method]
    // 
    long CurrSelGetFirst(); // [id(25), method]
    // 
    long CurrSelGetNext(); // [id(26), method]
    // 
    long DwgGetFirst(); // [id(27), method]
    // 
    long DwgGetNext(); // [id(28), method]
    // 
    void SelectOne(); // [id(29), method]
    // 
    long IsPgmSelDone(); // [id(30), method]
    // 
    long GetLastElem(); // [id(31), method]
    // 
    void ClearPgmSel(); // [id(32), method]
    // 
    void ClearSel(); // [id(33), method]
    // 
    bool AddToSel(long elemId); // [id(34), method]
    // 
    bool RemoveFromSel(long elemId); // [id(35), method]
    // 
    bool DelSel(); // [id(36), method]
    // 
    bool MoveSel(double x1, double y1, double x2, double y2); // [id(37), method]
    // 
    bool CopySel(double x1, double y1, double x2, double y2); // [id(38), method]
    // 
    bool RotateSel(double x1, double y1, double ang); // [id(39), method]
    // 
    bool ScaleSel(double x1, double y1, double xscale, double yscale); // [id(40), method]
    // 
    bool MirrorSel(double x1, double y1, double x2, double y2, bool del); // [id(41), method]
    // 
    bool AdjustSel(double x1, double y1, double x2, double y2, double x3, double y3, double x4, double y4); // [id(42), method]
    // 
    bool ChangeLineColor(long color); // [id(43), method]
    // 
    bool ChangeLineType(long type); // [id(44), method]
    // 
    bool ChangeLineWidth(double Width); // [id(45), method]
    // 
    bool ChangePointColor(long color); // [id(46), method]
    // 
    bool ChangePointType(long type); // [id(47), method]
    // 
    bool ChangePointSize(double size); // [id(48), method]
    // 
    bool ChangeTextFont(TAutoString FaceName, long weight, long color, long italic, long underline, long strikeOut); // [id(49), method]
    // 
    bool ChangeTextHgt(double hgt); // [id(50), method]
    // 
    bool ChangeTextWidth(double Width); // [id(51), method]
    // 
    bool ChangeTextAngle(double angle); // [id(52), method]
    // 
    bool ChangeTextOrient(double orient); // [id(53), method]
    // 
    bool ChangeTextJust(long just); // [id(54), method]
    // 
    bool ChangeFillColor(long color); // [id(55), method]
    // 
    bool ChangeFillType(long type); // [id(56), method]
    // 
    bool ChangeLayer(TAutoString layer); // [id(57), method]
    // 
    bool SetFilletParms(long type, double dist); // [id(58), method]
    // 
    bool Fillet(long elemId1, long elemId2, double x1, double y1, double x2, double y2); // [id(59), method]
    // 
    bool BreakEnd(long elemId, double x1, double y1, double x2, double y2); // [id(60), method]
    // 
    bool BreakMiddle(long elemId, double x1, double y1, double x2, double y2); // [id(61), method]
    // 
    bool Extend(long elemBnd, long elemExt, double x1, double y1); // [id(62), method]
    // 
    bool Offset(long elem, double dist); // [id(63), method]
    // 
    bool Explode(long elem); // [id(64), method]
    // 
    bool ChangeText(long elem, TAutoString text); // [id(65), method]
    // 
    bool OpenClosePline(long elem); // [id(66), method]
    // 
    bool RedefSym(TAutoString path); // [id(67), method]
    // 
    bool CopyBmp(double x1, double y1, double x2, double y2); // [id(68), method]
    // 
    bool ZoomWin(double x1, double y1, double x2, double y2); // [id(69), method]
    // 
    bool ZoomExt(); // [id(70), method]
    // 
    bool ZoomPrev(); // [id(71), method]
    // 
    bool ZoomFactor(double fact); // [id(72), method]
    // 
    bool ZoomPage(); // [id(73), method]
    // 
    bool ZoomPageExt(); // [id(74), method]
    // 
    bool Pan(double dx, double dy); // [id(75), method]
    // 
    bool Redraw(); // [id(76), method]
    // 
    bool SetLineColor(long color); // [id(77), method]
    // 
    bool SetLineType(long type); // [id(78), method]
    // 
    bool SetLineWidth(double Width); // [id(79), method]
    // 
    bool SetTextFont(TAutoString FaceName, double Height, long weight, long color, long italic, long underline, long strikeOut); // [id(80), method]
    // 
    bool SetTextHgt(double hgt); // [id(81), method]
    // 
    bool SetTextWidth(double Width); // [id(82), method]
    // 
    bool SetTextAngle(double angle); // [id(83), method]
    // 
    bool SetTextOrient(double orient); // [id(84), method]
    // 
    bool SetTextJust(long just); // [id(85), method]
    // 
    bool SetPointColor(long color); // [id(86), method]
    // 
    bool SetPointType(long type); // [id(87), method]
    // 
    bool SetPointSize(double Width); // [id(88), method]
    // 
    bool SetFillColor(long color); // [id(89), method]
    // 
    bool SetFillType(long type); // [id(90), method]
    // 
    bool SetDimArrowScale(double scale); // [id(91), method]
    // 
    bool SetDimOffset(double Offset); // [id(92), method]
    // 
    bool AddLayer(TAutoString layer); // [id(93), method]
    // 
    bool SetLayerLock(TAutoString layer, bool lock); // [id(94), method]
    // 
    bool SetLayerPrint(TAutoString layer, bool print); // [id(95), method]
    // 
    bool SetLayerOn(TAutoString layer, bool on); // [id(96), method]
    // 
    bool RenameLayer(TAutoString oldName, TAutoString newName); // [id(97), method]
    // 
    bool SetCurrentLayer(TAutoString layer); // [id(98), method]
    // 
    bool SetBasePt(double X, double Y); // [id(99), method]
    // 
    bool SetGridParms(double dx, double dy, double xo, double yo, long disp); // [id(100), method]
    // 
    bool SetNumFmt(long type, long ndec, long denom, long cdec); // [id(101), method]
    // 
    bool SetDispPage(bool disp); // [id(102), method]
    // 
    bool SetDispDxf(bool disp); // [id(103), method]
    // 
    bool SetSnapMode(long mode); // [id(104), method]
    // 
    void GetExtents(double far* xmin, double far* ymin, double far* xmax, double far* ymax); // [id(105), method]
    // 
    void GetPoint(); // [id(106), method]
    // 
    long IsPointSelDone(double far* X, double far* Y); // [id(107), method]
    // 
    void SetPrompt(TAutoString text); // [id(108), method]
    // 
    long GetElemType(long elemId); // [id(109), method]
    // 
    void GetLineElem(LineElem&, long elemId); // [id(110), method]
    // 
    void GetArcElem(ArcElem&, long elemId); // [id(111), method]
    // 
    void GetCircleElem(CircleElem&, long elemId); // [id(112), method]
    // 
    void GetPointElem(PointElem&, long elemId); // [id(113), method]
    // 
    void GetTextElem(TextElem&, long elemId); // [id(114), method]
    // 
    void GetPlineElem(PlineElem&, long elemId); // [id(115), method]
    // 
    void GetInsertElem(InsertElem&, long elemId); // [id(116), method]
    // 
    void GetFillElem(FillElem&, long elemId); // [id(117), method]
    // 
    void GetBmpElem(BmpElem&, long elemId); // [id(118), method]
    // Application object
    void GetApplication(TGcadApp&); // [id(119), propget]
};
